#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define BUF_LEN 4096
#define CLR_STDIN() while(getchar() != '\n'){}

int main() {
  char buf[BUF_LEN+1];
  char letter;
  unsigned int mode;
  FILE *fp;
  int rc;

  do {
    printf("Enter file name: ");
    rc = scanf("%s", buf);
    if (rc == 1) break;
  } while(1);

  fp = fopen(buf, "r");
  if (fp == NULL) {
    printf("Unable to open file '%s'\n", buf);
    return -1;
  }

  printf("---Formats---\n");
  printf("1) Character only\n");
  printf("2) ASCII only\n");
  printf("3) Character and ASCII\n");

  do {
    printf("Select format: ");
    rc = scanf("%d", &mode);
    CLR_STDIN();
    if (rc == 1 && mode < 4 && mode > 0) break;
  } while(1);

  while ((letter = fgetc(fp)) != EOF) {
    if (mode == 1 || mode == 3) printf("Character: %c", letter);
    if (mode == 3) printf(" ");
    if (mode == 2 || mode == 3) printf("ASCII: %u", letter);
    printf("\n");
  }

  fclose(fp);
  return 0;
}
